#!/usr/bin/perl

die "aggregate.pl [-sum] [-g granularity] [-o offset] file" if (@ARGV < 1);

$sum = 0;
$offset = 0.0;
$granularity = 1.0;

while ($ARGV[0] =~ /^-/) {
    $op = shift;
    if ($op eq "-sum") {
	$sum = 1;
    } elsif ($op eq "-g") {
	$granularity = shift;
    } elsif ($op eq "-o") {
	$offset = shift;
    }

}

$oldtime = 0;
$a_data = 0;

open(infile, $ARGV[0]) or die "couldn't open infile $ARGV[0]";

while ($line = <infile>) {
    chomp $line;
    next if ($line =~ /^#/);
    ($time, $data) = split(/\s+/, $line);
    next if ($time < $offset);
    $a_data += $data;
    ++$a_sample;
    if (($time - $oldtime) >= $granularity) {
	$oldtime = $time;
	if ($a_sample > 0) {
	    print $oldtime, " ", ($sum == 1) ? $a_data : $a_data / $a_sample, "\n";
	} else {
	    print $oldtime, " 0\n";
	}
	$a_data = 0;
	$a_sample = 0;
    }
}
if ($a_sample > 0) {
    print $time, " ", ($sum == 1) ? $a_data : $a_data / $a_sample, "\n";
} else {
    print $time, " 0\n";
}

close(infile);
