#!/usr/bin/perl

$rx = "";
$ry = "";
$lx = 0;
$ly = 0;
$title = "notitle";
$tcol = 0;
$out = "graph.ps";
$line = 0;

$max_titles = 5;

@protocols = ("tfmcc", "tfrc", "tcp", "pcc", "tear", "pareto", "cbr");
@pcol      = (1,2,3,4,5,6,7);
@pnum      = ();

while ($ARGV[0] =~ /^-/) {
    $p = shift;
    $rx = shift if ($p eq "-x" && @ARGV > 0);
    $ry = shift if ($p eq "-y" && @ARGV > 0);
    $line = shift if ($p eq "-line" && @ARGV > 0);
    $title = shift if ($p eq "-t" && @ARGV > 0);
    $out = shift if ($p eq "-o" && @ARGV > 0);
    $size = shift if ($p eq "-size" && @ARGV > 0);
    $lx = 1 if ($p eq "-lx");
    $ly = 1 if ($p eq "-ly");
    $tcol = 1 if ($p eq "-c");
}

if (@ARGV == 0) {
    print "usage: fplot.pl [-x xrange] [-y yrange] [-t title] [-o outname] [-lx] [-ly] [-line yval] [-size size] [-c] file1 ...\n";
    exit 1;
}

$rx = "1:" if ($rx eq "" && lx == 1);
$ry = "1:" if ($ry eq "" && ly == 1);
$title = $out if ($title eq "notitle");

open(cmd, ">cmd.tmp") or die;
print cmd "set term post eps color solid 24\n";
print cmd "set output \"$out\"\n";
print cmd "set size $size\n" if ($size ne "");
print cmd "set title \"$title\"\n";
print cmd "set xlabel \"Time (s)\"\n";
print cmd "set ylabel \"Throughput (KBit/s)\"\n";
print cmd "set lmargin 10\n";
print cmd "set xrange [$rx]\n" if ($rx ne "");
print cmd "set yrange [$ry]\n" if ($ry ne "");
print cmd "set logscale x\n" if ($lx);
print cmd "set logscale y\n" if ($ly);
print cmd "plot ";
print cmd "$line w l 0, " if ($line != 0);
for ($i = 0; $i < @ARGV; ++$i) {
    print cmd ", " if ($i > 0);
    $l = $i + 1; $n = "";
    foreach ($j = 0; $j < @protocols; ++$j) {
	if ($ARGV[$i] =~ /$protocols[$j]/) {
	    ++$pnum[$j];
	    $l = $pcol[$j] if ($tcol);
	    $n = "not" if ($pnum[$j] > $max_titles);
	}
    }
    print cmd "\"$ARGV[$i]\" $n w l $l";
}
print cmd "\n";
close(cmd);
system "gnuplot cmd.tmp";
system "rm cmd.tmp";
