#!/usr/bin/perl

$rx = "";
$ry = "";
$lx = 0;
$ly = 0;
$title = "";
$tcol = 0;
$out = "graph.ps";
$line = 0;

$max_titles = 5;

while ($ARGV[0] =~ /^-/) {
    $p = shift;
    $rx = shift if ($p eq "-x" && @ARGV > 0);
    $ry = shift if ($p eq "-y" && @ARGV > 0);
    $line = shift if ($p eq "-line" && @ARGV > 0);
    $title = shift if ($p eq "-t" && @ARGV > 0);
    $out = shift if ($p eq "-o" && @ARGV > 0);
    $size = shift if ($p eq "-size" && @ARGV > 0);
    $tcol = 1 if ($p eq "-c");
}

if (@ARGV < 2) {
    print "usage: rplot.pl [-x xrange] [-y yrange] [-t title] [-o outname] [-line yval] [-size size] [-c] file recv-nr\n";
    exit 1;
}

$rx = "1:" if ($rx eq "" && lx == 1);
$ry = "1:" if ($ry eq "" && ly == 1);
$title = $out if ($title eq "");

$name = $ARGV[0];
$nr = $ARGV[1];

system("grep ^r$nr $name > tmp.log");

open(cmd, ">cmd.tmp") or die;
print cmd "set term post eps color solid 24\n";
print cmd "set output \"$out\"\n";
print cmd "set size $size\n" if ($size ne "");
print cmd "set title \"$title\"\n";
print cmd "set xlabel \"Time (s)\"\n";
#print cmd "set ylabel \"Bandwidth (KBit/s)\"\n";
print cmd "set lmargin 10\n";
print cmd "set rmargin 10\n";
print cmd "set xrange [$rx]\n" if ($rx ne "");
print cmd "set yrange [0:]\n";
print cmd "set multiplot\n";
print cmd "set noytics\n";
print cmd "set y2tics\n";
print cmd "set y2label \"loss rate\"\n";
print cmd "set ylabel \"\"\n";
print cmd "plot 0 w l 0, \"tmp.log\" u 2:4 t \"loss rate\" w l 3\n";
print cmd "set noy2tics\n";
print cmd "set ytics\n";
print cmd "set ylabel \"RTT\"\n";
print cmd "set y2label \"\"\n";
print cmd "plot 0 w l 0, \"tmp.log\" u 2:5 t \"RTT\" w l 2\n";
print cmd "set noytics\n";
print cmd "set ylabel \"\"\n";
print cmd "plot \"tmp.log\" u 2:7 t \"throughput\" w l 1\n";
close(cmd);
system "gnuplot cmd.tmp";
system "rm cmd.tmp tmp.log";
